// A modified version for this project: https://github.com/zhangbozhb/WebViewBridge.Swift

var MagpieBridge = window.MagpieBridge || {};
window.MagpieBridge = MagpieBridge;

MagpieBridge.Core = MagpieBridge.Core || (function() {
    var callbackId = 1;
    var callbacks = {};

    var dispatchAction = function() {
        var actionName = arguments[0];
        var actionArgs = arguments[1] || {};
        var actionCallback = arguments[2];
        var actionId = ++callbackId;

        if (actionCallback) {
            callbacks[actionId] = actionCallback;
        } else {
            actionId = 0;
        }

        var action = {
            id: actionId,
            name: actionName,
            data: actionArgs
        };
        if (window.yamibuy_messageHandlers &&
            window.yamibuy_messageHandlers.MagpieBridge &&
            window.yamibuy_messageHandlers.MagpieBridge.postMessage) {
            window.yamibuy_messageHandlers.MagpieBridge.postMessage(JSON.stringify([action]))
        }
        if (test && test.handAction){
            test.handAction(JSON.stringify([action]));
        }
    };

    var callbackResult = function() {
        var data = arguments[0];
        if (!data) {
            return
        }
        var callInfo = JSON.parse(data);
        var callbackId = callInfo["id"];
        var status = callInfo["status"];
        var data = callInfo["result"];
        if (!callbackId || status == undefined || data == undefined) {
            return
        }
        var callback = callbacks[callbackId];
        if (!callback) {
            return
        }
        var result = callback(status, data);
        return result != undefined ? JSON.stringify(result) : undefined;
    };

    var ready = function() {
        var readyFunction = arguments[0];
        if (readyFunction) {
            document.addEventListener("DOMContentLoaded", readyFunction);
        }
    };

    return {
        dispatchAction: dispatchAction,
        callbackResult: callbackResult,

        ready: ready
    }
}());

MagpieBridge.Core.ready(function() {
    MagpieBridge.Yamibuy = MagpieBridge.Yamibuy || (function() {
        var queryToken = function(done) {
            MagpieBridge.Core.dispatchAction(
                "User.QueryToken", [],
                function(status, data) {
                    status ? done(data) : done("")
                });
        };

        var checkLogin = function(purchaseId,done) {
            MagpieBridge.Core.dispatchAction(
                "User.CheckLogin", {purchase_id:purchaseId},
                function(status, data) {
                    status ? done(data) : done("")
                });
        };

        var finishPayment = function(purchaseId,done) {
            MagpieBridge.Core.dispatchAction(
                "Order.FinishPayment", {purchase_id:purchaseId},
                function(status, data) {
                    status ? done(data) : done("")
                });
        };

        var cancelPayment = function(purchaseId,done) {
            MagpieBridge.Core.dispatchAction(
                "Order.CancelPayment", {purchase_id:purchaseId},
                function(status, data) {
                    status ? done(data) : done("")
                });
        };

        return {
            queryToken: queryToken,
            checkLogin: checkLogin,
            finishPayment: finishPayment,
            cancelPayment: cancelPayment
        }
    }());
});
